#!/usr/bin/perl

use strict;

my %U_net = ();
my %U_atts = ();

load_hprd_network();
load_human_network("H70-PL0.9.txt");
load_mouse_network("M70-PL0.9.txt");


## adding_the_flags
foreach my $n1 (sort(keys(%U_net))) {
	foreach my $n2 (sort(keys(%{ $U_net{$n1} }))) {	
		my $human_f = 0;
		my $mouse_f = 0;
		my $HPRD_f = 0;

		if (defined($U_net{$n1}{$n2}{"human_plos"})) {
			$human_f = 1;
		}

		if (defined($U_net{$n1}{$n2}{"mouse_plos"})) {
			$mouse_f = 1;
		}

		if (defined($U_net{$n1}{$n2}{"hprd_experiment_type"})) {
			$HPRD_f = 1;
		}
		my %atts = ();
		$atts{"F_hprd"} = $HPRD_f;
		$atts{"F_human"} = $human_f;
		$atts{"F_mouse"} = $mouse_f;

		store_atts($n1, $n2, \%atts);
	}
}



## dumping
open(OS, ">human_mouse_HPRD_union_small.txt") or die "Can't open the small output file\n";
open(O, ">human_mouse_HPRD_union.txt") or die "Can't open the output file\n";

print O "n1\tn2\t" . join("\t",sort(keys(%U_atts))) . "\n";
foreach my $n1 (sort(keys(%U_net))) {
	foreach my $n2 (sort(keys(%{ $U_net{$n1} }))) {
		print O "$n1\t$n2";
		foreach my $a (sort(keys(%U_atts))) {
			print O "\t" . $U_net{$n1}{$n2}{$a};
		}
		print O "\n";

		print OS "$n1\t$n2\t" .
			$U_net{$n1}{$n2}{"F_hprd"} . "\t" .
			$U_net{$n1}{$n2}{"F_human"} . "\t" .
			$U_net{$n1}{$n2}{"F_mouse"} . "\n";

	}
}
close(O);
close(OS);

sub store_atts {
	my ($n1, $n2, $atts_r) = @_;

	if ($n1 > $n2) {
		die "REALLY NOT GOOD!!!!\n";
	}

	foreach my $a (keys(%{ $atts_r })) {
		$U_net{$n1}{$n2}{ $a } = $atts_r->{$a};
		$U_atts{$a} = 1;
	}
}

sub load_human_network() {
        my $file_name = shift;
        open(F, $file_name) or die "Can't load the human network from $file_name network file\n";
        my $nn = 0;
        while (my $line = <F>) {
		chomp($line);
                my @cs = split(/\t/, $line);
                if (scalar(@cs) != 10) {
                        die "worng number of columns (" . scalar(@cs) . ") in the line: |$line| in the network file $file_name\n";
                }
                my ($n1, $n2, $ha_n, $ga_n, $gam_n, $ats, $plos, $hiids, $m_sc, $m_pr) = @cs;
                if ($n1 > $n2) {
                        die "AAAAAAAAAAAAAaaaa\n";
                }

		my %atts = ();
		$atts{"human_ha_n"} = $ha_n;
		$atts{"human_ga_n"} = $ga_n;
		$atts{"human_gam_n"} = $gam_n;
		$atts{"human_ats"} = $ats;
		$atts{"human_plos"} = $plos;
		$atts{"human_hiids"} = $hiids;
		$atts{"human_m_sc"} = $m_sc;
		$atts{"human_m_pr"} = $m_pr;
		store_atts($n1, $n2, \%atts);
        }
        close(F);
}


sub load_mouse_network() {

	## First loading the orthologs mapping
	my %h_to_m = ();
	my %m_to_h = ();


        open(H,"HMD_Human5.rpt.txt") or die "Can't quite open the HMD_Human5.rpt.txt file\n";
        my $line_number = 0;
        while (my $line = <H>) {
                $line_number++;
		chomp($line);
                my @cs = split(/\t/, $line);
                if (scalar(@cs) != 10) {
                        # print "Line $line_number has " . scalar(@cs) . " columns\n";
                        next;
                }
                my $h_gid = $cs[1];
                my $m_gid = $cs[6];

                if ($h_gid =~ /Human/) {
                        next;
                }

                if (($h_gid =~ /^\s*$/) || ($m_gid =~ /^\s*$/)) {
                        next;
                }

                if (defined($h_to_m{$h_gid})) {
                        die "The human id $h_gid is repeated twice in the othologs\n";
                }
                if (defined($m_to_h{$m_gid})) {
                        die "The human id $m_gid is repeated twice in the othologs\n";
                }

                $h_to_m{$h_gid} = $m_gid;
                $m_to_h{$m_gid} = $h_gid;

        }
        close(H);


	## second loading and mapping the mouse genes.

        my $file_name = shift;
        open(F, $file_name) or die "Can't load the human network from $file_name network file\n";
        my $nn = 0;
        while (my $line = <F>) {
		chomp($line);
                my @cs = split(/\t/, $line);
                if (scalar(@cs) != 10) {
                        die "worng number of columns (" . scalar(@cs) . ") in the line: |$line| in the network file $file_name\n";
                }
                my ($m_n1, $m_n2, $ma_n, $ga_n, $gam_n, $ats, $plos, $hiids, $m_sc, $m_pr) = @cs;
                if ($m_n1 > $m_n2) {
                        die "BBBBBBBBBBbbbbbbb\n";
                }

		my $n1 = $m_to_h{$m_n1};
		my $n2 = $m_to_h{$m_n2};

                if ($n1 > $n2) {
			my $t = $n1;
			$n1 = $n2;
			$n2 = $t;

			$t = $m_n1;
			$m_n1 = $m_n2;
			$m_n2 = $t;
		}

		if (defined($n1) && defined($n2)) {
			my %atts = ();
			$atts{"mouse_n1"} = $m_n1;
			$atts{"mouse_n2"} = $m_n2;
			$atts{"mouse_ha_n"} = $ma_n;
			$atts{"mouse_ga_n"} = $ga_n;
			$atts{"mouse_gam_n"} = $gam_n;
			$atts{"mouse_ats"} = $ats;
			$atts{"mouse_plos"} = $plos;
			$atts{"mouse_hiids"} = $hiids;
			$atts{"mouse_m_sc"} = $m_sc;
			$atts{"mouse_m_pr"} = $m_pr;

			store_atts($n1, $n2, \%atts);
		}

        }
        close(F);
}


sub load_hprd_network {
	open(I,"HPRD_Release_7_09012007.txt") or die "Can't open HPRD_Release_7_09012007.txt\n";
	scalar(<I>);
	while (my $line = <I>) {
		chomp($line);
		my @cs = split(/\t/, $line);
		if (scalar(@cs) != 6) {
			die "Wrong number of columns " . scalar(@cs) . "\n";
		}
		my $up_str = @cs[1];
		my $dn_str = @cs[3];
		my $pmid = @cs[5];
		my $exp_type = @cs[4];

		# my $up = n_str_to_geneid($up_str);
		# my $dn = n_str_to_geneid($dn_str);

		my $up = $up_str;
		my $dn = $dn_str;

		if (($up == 0) || ($dn == 0)) {
			print STDERR "skipping because of 0 id\n";
			next;
		}
		if ($up > $dn) {
			# print STDERR "Strange order up: $up, dn: $dn\n";
			# die "Strange order up: $up, dn: $dn\n";
			my $t = $up;
			$up = $dn;
			$dn = $t;
		}


		if ($exp_type eq "") {
			die "LELELELELE\n";
		}
		my %atts = ();
		$atts{"hprd_pmid"} = $pmid;
		$atts{"hprd_experiment_type"} = $exp_type;
		store_atts($up, $dn, \%atts);
		
	}
	close(I);
}

